/*
       Licensed to the Apache Software Foundation (ASF) under one
       or more contributor license agreements.  See the NOTICE file
       distributed with this work for additional information
       regarding copyright ownership.  The ASF licenses this file
       to you under the Apache License, Version 2.0 (the
       "License"); you may not use this file except in compliance
       with the License.  You may obtain a copy of the License at

         http://www.apache.org/licenses/LICENSE-2.0

       Unless required by applicable law or agreed to in writing,
       software distributed under the License is distributed on an
       "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
       KIND, either express or implied.  See the License for the
       specific language governing permissions and limitations
       under the License
*/
/**
 * TagToken.java
 *
 * Created on December 25, 2003, 12:24 PM
 * @author  Valter Crescenzi
 */

package roadrunner.parser.token;


import java.io.File;
import java.util.Map;

import roadrunner.ast.ASTToken;
import roadrunner.parser.Token;

class TagToken extends ASTToken implements Token {
    
    private Tag tag;
        
    /** Creates a new instance of TagToken */
    TagToken(Tag tag, int code, int depth) {
        super(depth,code);
        this.tag = tag;
    }
    
    public String getText() { throw new RuntimeException("This object is supposed to be a tag Token!"); }
    public String getElement() { return this.tag.getElement(); }
    public Map getAttributes() { return this.tag.getAttributes(); }
    
    public boolean isIMG()  { return false; }
    public boolean isLink() { return false; }
    
    public String getVariantValue() {
        throw new RuntimeException("This is not a variant!");
    }
    
    /* N.B. equals() and hashCode() must conform to the semantics of ASTToken equals() and hashCode() */
    public String toString()     { return "<"+(isStartTag()?"":"/")+this.tag+">"; }
    
}
