/*
       Licensed to the Apache Software Foundation (ASF) under one
       or more contributor license agreements.  See the NOTICE file
       distributed with this work for additional information
       regarding copyright ownership.  The ASF licenses this file
       to you under the Apache License, Version 2.0 (the
       "License"); you may not use this file except in compliance
       with the License.  You may obtain a copy of the License at

         http://www.apache.org/licenses/LICENSE-2.0

       Unless required by applicable law or agreed to in writing,
       software distributed under the License is distributed on an
       "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
       KIND, either express or implied.  See the License for the
       specific language governing permissions and limitations
       under the License
*/
/*
 * ConfigTest.java
 * JUnit based test
 *
 * Created on 23 febbraio 2003, 17.48
 * @author Valter Crescenzi
 */

package roadrunner.config;

import junit.framework.*;

import java.io.*;
import java.util.*;
import java.util.logging.*;

import org.w3c.dom.Node;

import roadrunner.FixtureOnFile;

public class ConfigTest extends TestCase {
  
  final static private String upfn = "u.xml";
  
  public ConfigTest(java.lang.String testName) {
    super(testName);
  }
  
  public static void main(java.lang.String[] args) {
    junit.textui.TestRunner.run(suite());
  }
  
  public static Test suite() {
    TestSuite suite = new TestSuite(ConfigTest.class);
    
    return suite;
  }
    
  /** Test of getPrefs method, of class roadrunner.Config. */
  public void testGetPrefs() {
    System.out.println("testGetPrefs");
    Config.getPrefs();
  }
  
  /** Test of load method, of class roadrunner.Config. */
  public void testLoad() throws IOException {
    System.out.println("testLoad");
    Config.load(FixtureOnFile.getPreferencesFile(upfn));
  }
  
  
  // Add test methods here, they have to start with 'test' name.
  // for example:
  // public void testHello() {}
    
  
}
